﻿package compo_ritual
{
    import flash.display.Bitmap;
    import flash.display.BitmapData;
    import flash.geom.Matrix;
    import flash.media.Sound;
    import flash.media.SoundChannel;
    import meyermike.core.GameObject;
    import meyermike.core.GameObjectHolder;
    import meyermike.Sounds;
    /**
     * getting game sounds and graphics out of the logic's way
     * @author Mike Meyer
     */
    public class GameContent
    {
        [Embed(source = 'assets/tuffy/Tuffy.ttf', fontName = "Tuffy")]
        private static const _tuffyFont:Class;
        public static const TuffyFont:String = "Tuffy";

        [Embed(source = 'assets/tuffy/Tuffy_Bold.ttf', fontName = "TuffyBold", fontWeight="bold")]
        private static const _tuffyFontBold:Class;
        public static const TuffyBoldFont:String = "TuffyBold";

        [Embed(source='assets/block.png')]
        private static const _platformTileBmpClass:Class;
        private static const _platformTileBmp:Bitmap = new _platformTileBmpClass();
        public static const PlatformTileBmpData:BitmapData = _platformTileBmp.bitmapData;

        [Embed(source='assets/spike.png')]
        private static const _spikeTileBmpClass:Class;
        private static const _spikeTileBmp:Bitmap = new _spikeTileBmpClass();
        public static const SpikeTileBmpData:BitmapData = _spikeTileBmp.bitmapData;

        [Embed(source='assets/item1_0.png')]
        private static const ITEM1_0:Class;
        [Embed(source='assets/item1_5.png')]
        private static const ITEM1_5:Class;
        [Embed(source='assets/item1_6.png')]
        private static const ITEM1_6:Class;
        [Embed(source='assets/item1_7.png')]
        private static const ITEM1_7:Class;
        public static const ITEM1_FRAMES:Array = [ITEM1_0, ITEM1_0, ITEM1_0, ITEM1_0, ITEM1_0, ITEM1_0, ITEM1_0, ITEM1_0, ITEM1_0, ITEM1_0, ITEM1_0, ITEM1_0, ITEM1_0, ITEM1_5, ITEM1_6, ITEM1_7];

        [Embed(source='assets/item2_0.png')]
        private static const ITEM2_0:Class;
        [Embed(source='assets/item2_5.png')]
        private static const ITEM2_5:Class;
        [Embed(source='assets/item2_6.png')]
        private static const ITEM2_6:Class;
        [Embed(source='assets/item2_7.png')]
        private static const ITEM2_7:Class;
        public static const ITEM2_FRAMES:Array = [ITEM2_0, ITEM2_0, ITEM2_0, ITEM2_0, ITEM2_0, ITEM2_0, ITEM2_0, ITEM2_0, ITEM2_0, ITEM2_0, ITEM2_0, ITEM2_0, ITEM2_0, ITEM2_5, ITEM2_6, ITEM2_7];

        [Embed(source='assets/item3_0.png')]
        private static const ITEM3_0:Class;
        [Embed(source='assets/item3_5.png')]
        private static const ITEM3_5:Class;
        [Embed(source='assets/item3_6.png')]
        private static const ITEM3_6:Class;
        [Embed(source='assets/item3_7.png')]
        private static const ITEM3_7:Class;
        public static const ITEM3_FRAMES:Array = [ITEM3_0, ITEM3_0, ITEM3_0, ITEM3_0, ITEM3_0, ITEM3_0, ITEM3_0, ITEM3_0, ITEM3_0, ITEM3_0, ITEM3_0, ITEM3_0, ITEM3_0, ITEM3_5, ITEM3_6, ITEM3_7];

        [Embed(source='assets/spike.png')]
        private static const SPIKE_0:Class;
        [Embed(source='assets/spike5.png')]
        private static const SPIKE_5:Class;
        [Embed(source='assets/spike6.png')]
        private static const SPIKE_6:Class;
        [Embed(source='assets/spike7.png')]
        private static const SPIKE_7:Class;
        public static const SPIKE_FRAMES:Array = [SPIKE_0, SPIKE_0, SPIKE_0, SPIKE_0, SPIKE_0, SPIKE_0, SPIKE_0, SPIKE_0, SPIKE_0, SPIKE_0, SPIKE_0, SPIKE_0, SPIKE_0, SPIKE_5, SPIKE_6, SPIKE_7];

        private static var CollectSoundChannel:SoundChannel;

        [Embed(source='assets/collect1.mp3')]
        private static const Collect1SoundClass:Class;
        private static var Collect1Sound:Sound = new Collect1SoundClass();

        [Embed(source='assets/collect2.mp3')]
        private static const Collect2SoundClass:Class;
        private static var Collect2Sound:Sound = new Collect2SoundClass();

        [Embed(source='assets/collect3.mp3')]
        private static const Collect3SoundClass:Class;
        private static var Collect3Sound:Sound = new Collect3SoundClass();

        public static function PlaySound_Collect1():void
        {
            CollectSoundChannel = Sounds.PlaySound(Collect1Sound, CollectSoundChannel, 0.5);
        }
        public static function PlaySound_Collect2():void
        {
            CollectSoundChannel = Sounds.PlaySound(Collect2Sound, CollectSoundChannel, 0.5);
        }
        public static function PlaySound_Collect3():void
        {
            CollectSoundChannel = Sounds.PlaySound(Collect3Sound, CollectSoundChannel, 0.5);
        }

        private static var ImpactSoundChannel:SoundChannel;

        [Embed(source='assets/bigcollide.mp3')]
        private static const CollideSoundClass:Class;
        private static var CollideSound:Sound = new CollideSoundClass();
        public static function PlaySound_Collide():void
        {
            ImpactSoundChannel = Sounds.PlaySound(CollideSound, ImpactSoundChannel, 0.5);
        }

        private static var FootstepSoundChannel:SoundChannel;

        [Embed(source='assets/footstep.mp3')]
        private static const FootstepSoundClass:Class;
        private static var FootstepSound:Sound = new FootstepSoundClass();
        public static function PlaySound_Footstep():void
        {
            FootstepSoundChannel = Sounds.PlaySound(FootstepSound, FootstepSoundChannel, 0.25);
        }
        [Embed(source='assets/skid.mp3')]
        private static const SkidSoundClass:Class;
        private static var SkidSound:Sound = new SkidSoundClass();
        public static function PlaySound_Skid():void
        {
            FootstepSoundChannel = Sounds.PlaySound(SkidSound, FootstepSoundChannel, 0.25);
        }


        private static var VictorySoundChannel:SoundChannel;
        [Embed(source='assets/InaWinningMood.mp3')]
        private static const VictorySoundClass:Class;
        private static var VictorySound:Sound = new VictorySoundClass();
        public static function PlaySound_Victory():void
        {
            VictorySoundChannel = Sounds.PlaySound(VictorySound, VictorySoundChannel, 0.75);
        }

        /**
         * Add a platform to the scene
         */
        public static function addPlatform(layer:GameObjectHolder,  x:Number, y:Number, width:Number, height:Number):void
        {
            var go:GameObject = layer.Add();

            var m:Matrix = new Matrix();
            m.createBox( 4.0, 4.0 );
            go.graphics.beginBitmapFill(GameContent.PlatformTileBmpData, m);
            go.graphics.drawRect(
                0,
                0,
                width,
                height );
            go.graphics.endFill();

            go.x = x;
            go.y = y;
        }

        /**
         * Add a row of spikes to the scene
         */
        public static function addSpikes(layer:GameObjectHolder,  x:Number, y:Number, width:Number):void
        {
            var go:GameObject = layer.Add(Spike);

            var m:Matrix = new Matrix();
            m.createBox( 4.0, 4.0 );
            go.graphics.clear();
            go.graphics.beginBitmapFill(GameContent.SpikeTileBmpData, m);
            go.graphics.drawRect(
                0,
                0,
                width,
                32 );
            go.graphics.endFill();

            go.x = x;
            go.y = y;
        }
    }

}
