﻿package compo_ritual
{
    import meyermike.core.GameObject;
    import meyermike.util.spriteanim.SpriteAnimUtil;

    /**
     * ...
     * @author Mike Meyer
     */
    public class Item extends GameObject
    {
        private var mAnimUtil:SpriteAnimUtil;

        public override function Init():void
        {
            super.Init();
            AffectedByGravity = false;
        }

        public function SetAnimation(frames:Array, framerate:Number=8.0):void
        {
            if (null != mAnimUtil)
                throw new Error("Called SetAnimation when it already has a SpriteAnimUtil instance!");
            mAnimUtil = new SpriteAnimUtil(this)
            mAnimUtil.scaleX = 4;
            mAnimUtil.scaleY = 4;
            mAnimUtil.addAnimation("", frames, framerate);
            mAnimUtil.curAnim = "";
        }

        public override function Update(elapsedTime:Number):void
        {
            super.Update(elapsedTime);
            mAnimUtil.update(elapsedTime);
        }
    }

}
