﻿package compo_ritual.gamestates
{
    import compo_ritual.GameContent;
    import flash.events.Event;
    import flash.geom.Rectangle;
    import meyermike.constants.Colors;
    import meyermike.core.GameInterface;
    import meyermike.core.GameState;
    import meyermike.Settings;
    import meyermike.util.GuiBuilder;
    import meyermike.widget.PulsingTextButton;
    import meyermike.widget.TextField;

    /**
     * ...
     * @author Mike Meyer
     */
    public class YouWinScreen extends GameState
    {
        /**
         * initial setup
         */
        public override function Begin(game:GameInterface):void
        {
            super.Begin(game);

            var builder:GuiBuilder = new GuiBuilder(
                new Rectangle(0, 0, Settings.StageWidth, Settings.StageHeight),
                Game.Layers.UiLayer);
            builder.FontColor = Colors.WHITE_ENOUGH;
            builder.HighlightColor = Colors.WHITE;

            builder.AddScrim(0.5);

            builder.Font = GameContent.TuffyBoldFont;
            builder.FontSize = 144;
            builder.AddTextCentered("You Win!", 0.5, 0.40);
            builder.FontSize = 16;
            builder.AddTextCentered("Congratulations!", 0.5, 0.55);

            builder.FontSize = 56;
            builder.Font = GameContent.TuffyBoldFont;
            builder.AddButtonCentered("Play Again", PlayButtonPressed, 0.5, 0.7);

            GameContent.addPlatform(Game.Layers.PlatformLayer, 0, 0, Settings.StageWidth, Settings.StageHeight);

            Game.Music.StopMusic();
            GameContent.PlaySound_Victory();
        }

        /**
         * Start playing
         */
        private function PlayButtonPressed(e:Event = null):void
        {
            Game.ChangeGameState(new compo_ritual.gamestates.Game());
        }

        /**
         * Clean up!
         */
        public override function End():void
        {
            super.End();
            Game.Layers.RemoveAll();
        }
    }

}
