﻿package meyermike
{
    import meyermike.constants.Colors;
    /**
     * Set these values to change the default behaviors of various things
     * @author Mike Meyer
     */
    public class Settings
    {
        /**
         * get/set how wide it thinks the stage is.
         * the actual stage size may change, but this will remin the same
         * You should only set this BEFORE you varruct the game instance
         */
        public static var StageWidth:Number = 550;

        /**
         * get/set how tall it thinks the stage is.
         * the actual stage size may change, but this will remin the same
         * You should only set this BEFORE you varruct the game instance
         */
        public static var StageHeight:Number = 450;


        [Embed(source = 'assets/Fonts/StarPerv.ttf', fontName="StarPerv")]
        private static const _font:Class;

        /**
         * get/set the default font to use for textfields
         */
        public static var Font:String = "StarPerv";

        /**
         * get/set the default font size to use for textfields
         */
        public static var FontSize:Number = 18;

        /**
         * get/set the default color to use for textfields
         */
        public static var FontColor:Number = Colors.WHITE_ENOUGH;

        /**
         * get/set the default highlight color for rollover effects
         */
        public static var HighlightColor:Number = Colors.WHITE;

        /**
         * get/set the background color of the pause screen
         * Set this before constructing the game instance
         */
        public static var PauseScreenColor:Number = 0x000000;

        /**
         * get/set the font used on the pause screen
         * Set this before constructing the game instance
         */
        public static var PauseScreenFont:String = Settings.Font;

        /**
         * get/set the font color used on the pause screen
         * Set this before constructing the game instance
         */
        public static var PauseScreenFontColor:Number = Colors.WHITE;

        /**
         * get/set how opaque the pause screen is
         * Set this before constructing the game instance
         */
        public static var PauseScreenAlpha:Number = 0.5;

        /**
         * get/set the acceleration due to gravity in this game
         */
        public static var Gravity:Number = 2000;

        /**
         * get/set a maximum fall speed for this game
         */
        public static var MaxFallSpeed:Number = 600;

        /**
         * how fast the camera can move to keep up with it's follow target
         */
        public static var CameraSpeed:Number = 1000;

        /**
         * how many seconds ahead to predict the follow target's position
         */
        public static var CameraFollowLookAhead:Number = 0.0;
    }

}
