﻿package meyermike.collision
{
    import flash.events.Event;
    import meyermike.core.GameObject;



    /**
     * ...
     * @author Mike Meyer
     */
    public class CollisionEvent extends Event
    {
        public static const EVENT_COLLIDE:String = "collide";

        /// get/set the collision info for this collision
        public function get collisionInfo():CollisionInfo { return _collisionInfo; }
        private var _collisionInfo:CollisionInfo;

        /// get/set the object that the dispatcher collided with
        public function get object():GameObject { return _object; }
        private var _object:GameObject;

        public function CollisionEvent(collisionInfo:CollisionInfo, object:GameObject, bubbles:Boolean=false, cancelable:Boolean=false)
        {
            super(EVENT_COLLIDE, bubbles, cancelable);
            _collisionInfo = collisionInfo;
            _object = object;
        }

        public override function clone():Event
        {
            return new CollisionEvent(collisionInfo, object, bubbles, cancelable);
        }

        public override function toString():String
        {
            return formatToString("CollisionEvent", "type", "bubbles", "cancelable", "eventPhase");
        }

    }

}
