﻿package meyermike.debug
{
    import flash.display.DisplayObjectContainer;
    import flash.display.Sprite;
    import meyermike.core.GameObject;
    import meyermike.Settings;
    import meyermike.widget.TextField;

    /**
     * ...
     * @author Mike Meyer
     */
    public class DebugWidget extends GameObject
    {
        private var mOutputTab:DisplayObjectContainer;
        private var mOutputTextField:TextField;

        private static const BACKGROUND_ALPHA:Number = 0.5;

        private var _allowDebug:Boolean;
        public function get DebuggingFeaturesAllowed():Boolean { return _allowDebug; }

        /**
         * setup after first created or reused
         */
        public override function Init():void
        {
            super.Init();

            // allow debug stuff only when running locally
            _allowDebug = (loaderInfo.url.indexOf("file") == 0);

            if (_allowDebug)
            {
                CreateBackground();
                CreateTabBar();
                CreateOutputTab();
            }

            // starts out invisible
            this.visible = false;
        }

        /**
         * make the background to go behind everything
         */
        protected function CreateBackground():void
        {
            var background:Sprite = new Sprite();
            background.graphics.beginFill(0x000000);
            background.graphics.drawRect(
                0,
                0,
                Settings.StageWidth,
                Settings.StageHeight );
            background.graphics.endFill();
            background.alpha = BACKGROUND_ALPHA;
            this.addChild(background);
        }

        /**
         * create the clickable list of tabs
         */
        protected function CreateTabBar():void
        {
            // not doing it for this LD!
        }

        /**
         * make the output tab of the debugger
         */
        protected function CreateOutputTab():void
        {
            if (null == mOutputTab)
            {
                mOutputTab = new Sprite();
                mOutputTextField = new TextField();
                mOutputTab.addChild(mOutputTextField);
                mOutputTextField.Init();
                this.addChild(mOutputTab);
            }
        }

        /**
         * show output
         */
        public function Log(text:String):void
        {
            if (_allowDebug)
            {
                // TODO:  make into a ginormous scrolling thing someday
                mOutputTextField.SetText(text);
                this.visible = true;
            }
        }
    }

}
